﻿
using System;
using Wisej.Web;

namespace DGVCellControlTest
{
    public partial class Window1 : Form
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void Window1_Load(object sender, EventArgs e)
        {            
            this.dataGridView1.Rows.Add();
            this.dataGridView1.Rows[0]["column0"].Value = "50";
            this.dataGridView1.Rows[0].Height = 80;            
            Wisej.Web.Ext.jQueryKnob.Knob Knob = new Wisej.Web.Ext.jQueryKnob.Knob();
            Knob.Value = 50;
            Knob.Dock = DockStyle.Fill;
            this.dataGridView1.Rows[0]["column1"].Control = Knob;            
            Knob.Size = this.dataGridView1.Rows[0]["column1"].Size;
            Knob.UserData.Row = 0;
            Knob.ValueChanged += Knob_ValueChanged;
            Knob.BackColor = System.Drawing.Color.Black;

            Knob = new Wisej.Web.Ext.jQueryKnob.Knob();
            this.dataGridView1.Rows.Add();
            this.dataGridView1.Rows[1]["column0"].Value = "80";
            this.dataGridView1.Rows[1].Height = 80;
            Knob.Value = 80;
            Knob.Dock = DockStyle.Fill;
            this.dataGridView1.Rows[1]["column1"].Control = Knob;
            Knob.Size = this.dataGridView1.Rows[1]["column1"].Size;
            Knob.UserData.Row = 1;
            Knob.ValueChanged += Knob_ValueChanged;
            Knob.BackColor = System.Drawing.Color.White;
        }

        private void Knob_ValueChanged(object sender, EventArgs e)
        {
            Wisej.Web.Ext.jQueryKnob.Knob Knob = sender as Wisej.Web.Ext.jQueryKnob.Knob;
            if (Knob != null)
            {
                this.dataGridView1.Rows[Knob.UserData.Row]["column0"].Value = Knob.Value;
            }
        }

        private void dataGridView1_EditingControlShowing(object sender, DataGridViewEditingControlShowingEventArgs e)
        {
            if (dataGridView1.CurrentCell.ColumnIndex == 0)
            {
                var txtbox = e.Control as TextBox;
                txtbox.TextChanged += Txtbox_TextChanged;
            }            
        }

        private void Txtbox_TextChanged(object sender, EventArgs e)
        {
            Wisej.Web.Ext.jQueryKnob.Knob Knob = dataGridView1.Rows[dataGridView1.CurrentCell.RowIndex]["Column1"].Control as Wisej.Web.Ext.jQueryKnob.Knob;
            Knob.Value = Convert.ToInt32 (((sender as TextBox).Text));
        }
    }
}
